; ADW verwalten, 3 Eingnge AN0, AN6, AN7
; Ausgang:
; AN0 = Poti Linear fr Laser
; AN6 = Poti Regler fr Laser
; AN7 = Poti/Wippschalter am Laserkopf

.include "allgdef.inc"
.equ	samp,1				; b1
.equ	done,0				; b0

.global ADWcon,ADWinit

; ADW verwalten, 3 Eingnge AN0, AN6, AN7

ADWcon:
	mov		adwsta,w0
	bra		w0
	bra 	adwcon0
	bra 	adwcon1
	bra 	adwcon2
	bra		adwcon3
	bra		adwcon4
	bra		adwcon5
	bra		adwcon6
	
; Standby
adwcon0:
	inc		adwsta
    return
    
; AN0 = Poti "Linear"
adwcon1:
	clr		w0
	mov		w0,AD1CHS0		; AN0
	bclr	AD1CON1,#samp	; Starten
	inc		adwsta
	return

; AN0 fertig?
adwcon2:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	mov		w0,reglerpoti
; nchster: AN6 einschalten
adwcon2a:
	mov		#6,w0
	mov		w0,AD1CHS0		; AN6
	inc		adwsta
	return
	
; AN6 = Poti "Regler"
adwcon3:
	bclr	AD1CON1,#samp	; Starten
	inc		adwsta
	return

; AN6 fertig?
adwcon4:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	mov		w0,linearpoti
; nchster: AN7 einschalten
adwcon4a:
	mov		#7,w0
	mov		w0,AD1CHS0		; AN7
	inc		adwsta
	return

; AN7 = Schalter an der Laserdose
adwcon5:
	bclr	AD1CON1,#samp	; Starten
	inc		adwsta
	return

    ; AN7 fertig?
adwcon6:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	call	adwentprellen
	cp0		w1				; war OK ?
	bra		z,adwcon6d		; nein
	bset	merker,#adwfertig
	cp		w0,#45        	; AUS ?
	bra		lt,adwcon6a     ; ja
	mov		#846,w1
	cp		w0,w1        ; AUTO ?
	bra		gt,adwcon6b     ; Ja
; Lasermod: HAND
	sub     w0,#90
	btsc	w0,#15			; ins Neg?
	clr		w0
	mov		w0,handpoti		; 0...672
	mov		#1,w1
	bra		adwcon6c
; Lasermod: AUS
adwcon6a:
	bclr	merker,#handfertig
	mov		#0,w1
	bra		adwcon6c
; Lasermod: AUTO
adwcon6b:
	bclr	merker,#handfertig
	mov		#2,w1
adwcon6c:
	mov		w1,laserkopfschalter
; nchster: AN0 einschalten
adwcon6d:
	mov		#0,w0
	mov		w0,AD1CHS0		; AN0
	mov		#1,w0
	mov		w0,adwsta
	bset	AD1CON1,#samp	; Starten
	return
	
; gibt den messwert erst nach 10 identischen Messungen aus
; Eingang: w0, Ausgang: w1=0 > nicht bernehmen
adwentprellen:
	mov		handzsp,w1
	sub		w0,w1,w2
	inc2	w2,w2
	cp		w2,#5
	bra		le,adwentpr1	; gendert ?
	mov		w0,handzsp		; ja, zum zsp
	mov		#10,w0
	mov		w0,handzlr
	clr		w1
	return
adwentpr1:
	mov		handzlr,w1
	cp0		w1
	bra		z,adwetpr2
	dec		handzlr
	clr		w1
	return
adwetpr2:
	mov		#1,w1
	return

; --------------------- UPs --------------------	

; ADW Initialisierung fr einzelne Wandlungen
; Gewhlter Ablauf:
; Kanal whlen in ADCHS
; etwas warten
; Sample mit SAMP=1 starten, danach startet die Wandlung automatisch
; ende der Wandlung wenn DONE=1
; Wert aus ADCBUF0 holen
; nach S.20

	
ADWinit:
	mov		#0x0004,w0 		; auto-sample
	mov		w0,AD1CON1
	mov		#0x0,w0
	mov		w0,AD1CON2
	mov		#0x000F,w0
	mov		w0,AD1CON3
	mov		#0x0,w0
	mov		w0,AD1CON4	
	mov		#0,w0  			; CH1 = AN0
	mov		w0,AD1CHS0
	mov		#0,w0
	mov		w0,AD1CHS123
	mov		#0,w0
	mov		w0,AD1CSSL
	mov		#0,w0
	mov		w0,AD1CSSH
	bset	AD1CON1,#15
	return
	
	

	