; TFT-Display MAR3501 initialisieren

.include "allgdef.inc"
.global	Lcdinit,Commandozumtft,Datenzumtft,Tftclr

Lcdinit:
	bset	LATB,#lcd_rd
	call	Lcdreset
	
	mov		#0xC0,w1
	mov		#0x19,w2
	mov		#0x1a,w3
	rcall	Zumtft3byte
	
	mov		#0xC1,w1
	mov		#0x45,w2
	mov		#0x00,w3
	rcall	Zumtft3byte

   	mov		#0xC2,w1  		; Normal Mode
	mov		#0x33,w2
	rcall	Zumtft2byte

	mov		#0xC5,w1		; VCOM Control 1
	mov		#0x00,w2
	mov		#0x28,w3
	rcall	Zumtft3byte

	mov		#0xb1,w1		; Fram Rate Control
	mov		#0x90,w2
	mov		#0x11,w3
	rcall	Zumtft3byte

   	mov		#0xb4,w1      	; Inversion Control
	mov		#0x02,w2
	rcall	Zumtft2byte

	mov		#0xb6,w1		; Function Control
	mov		#0x00,w2
	mov		#0x42,w3
	mov		#0x3b,w4
	rcall	Zumtft4byte

   	mov		#0xb7,w1      	; Entry Mode Set
	mov		#0x07,w2
	rcall	Zumtft2byte

	mov		#15,w6
	mov		#psvoffset(posgamma),w5
	call	Zumtftinitstring

	mov		#15,w6
	mov		#psvoffset(neggamma),w5
	call	Zumtftinitstring
	
   	mov		#0x36,w1      	; Memory Access Control
	mov		#0x68,w2
	rcall	Zumtft2byte

   	mov		#0x3a,w1      	; Interface Pixel Format 16,16
	mov		#0x55,w2
	rcall	Zumtft2byte

	mov		#0x11,w1       	; Sleep  out
	rcall	Commandozumtft
	bset	LATB,#lcd_cs

	rcall	Warten100ms
	rcall	Warten100ms
	
	mov		#0x29,w1  		; Display ON
	rcall	Commandozumtft
	bset	LATB,#lcd_cs
	rcall	Warten100ms
	rcall	Tftclr
    return

;-----------------------------------------------------
; div. UPs
;-----------------------------------------------------
			
; Eingang: w5 = Adresse der Daten-Tabelle, w6 = Anzahl der Byte excl. Befehl
Zumtftinitstring:
	mov		[w5++],w1
	rcall	Commandozumtft
zumtfti1:
	mov		[w5++],w1
	rcall	Datenzumtft
	dec		w6,w6
	bra		nz,zumtfti1
	bset	LATB,#lcd_cs
	return

; Eingang: w1=Befehl, w2 = Daten	
Zumtft2byte:
	rcall	Commandozumtft
	mov		w2,w1
	rcall	Datenzumtft
	bset	LATB,#lcd_cs
	return
	
; Eingang: w1=Befehl, w2, w3 = Daten	
Zumtft3byte:
	rcall	Commandozumtft
	mov		w2,w1
	rcall	Datenzumtft
	mov		w3,w1
	rcall	Datenzumtft
	bset	LATB,#lcd_cs
	return

; Eingang: w1=Befehl, w2, w3, w4  = Daten	
Zumtft4byte:
	rcall	Commandozumtft
	mov		w2,w1
	rcall	Datenzumtft
	mov		w3,w1
	rcall	Datenzumtft
	mov		w4,w1
	rcall	Datenzumtft
	bset	LATB,#lcd_cs
	return
	
; Eingang: 	Befehl in w1
; Ausgang:	lcd_cs noch aktiv
Commandozumtft:
	mov		LATB,w0
	and		#0xff,w0
	swap	w1
	ior		w0,w1,w0
	mov		w0,LATB
	bclr	LATB,#lcd_cs
	bclr	LATB,#lcd_rs
	bclr	LATB,#lcd_wr
	bset	LATB,#lcd_wr
	bset	LATB,#lcd_rs
	return	

; Eingang: 	Befehl in w1
; Ausgang:	lcd_CS noch aktiv
Datenzumtft:
 	mov		LATB,w0
	and		#0xff,w0
	swap	w1
	ior		w0,w1,w0
	mov		w0,LATB
 	bclr	LATB,#lcd_wr
	bset	LATB,#lcd_wr
	return	
	
Lcdreset:
	bclr	LATB,#lcd_rst
	call	Warten100ms
	bset	LATB,#lcd_rst
	call	Warten100ms
	return

Warten100ms:
	mov		#100,w0
w100ms1:
	call	warten1ms
	dec		w0,w0
	bra		nz,w100ms1
	return
warten1ms:
	mov		#2600,w1
w1ms1:
	nop
	dec		w1,w1
	bra		nz,w1ms1
	return

; TFT komplett auf Farbe #weiss setzen
Tftclr:
	clr		nachunten
	mov		#2,w1
	mov		w1,schriftgroesse
	mov		#weiss,w2
	mov		w2,schriftfarbe
tftclr0:
	mov		#lcdpuffer,w0
	mov		w0,lcdzgr
	clr		zeile
	clr		spalte
	mov		#0x20,w1
	repeat	#20
	mov		w1,[w0++]	; lcdpuffer fllen
	nop
	clr		w1
	mov		w1,[w0]		; Endezeichen
	bset	merker,#lcdaktiv
	nop
tftclr1:
	call	Lcdbed
	btsc	merker,#lcdaktiv
	bra		tftclr1	
tftclr2:
	mov		nachunten,w1
	add		#50,w1
	mov		w1,nachunten
	mov		#320,w2
	cp		w2,w1
	bra		c,tftclr0
	return
		