; LASERCON erzeugt die PWM fr den Laserkopf

.Global Lasercon

.include "allgdef.inc"
.include "p33EP64GP504.inc"

Lasercon:
; Laserkopf angeschlossen?
	btsc    inputdaten,#laserstecker
	bra		laserconv
	clr		lasersta
	call	Laserreset
	return
laserconv:
	call	Aufabtest
	mov		lasersta,w0
	bra		w0
	
	bra		lasercon0
	bra		lasercon1
	bra		lasercon2
	
lasercon0:
	mov		laserkopfschalter,w0
; Hand ?
	cp		w0,#1
	bra		nz,lasercon0a
	call	Laserreset
	MOV 	#0x0001, w3 		
	MOV 	w3, OC2RS       
	bset	T3CON, #TON
	mov		#1,w0 
	mov		w0,lasersta
	return

; AUTO ?
lasercon0a:
	cp		w0,#2
	bra		nz,lasercon0b
	call	Laserreset
	MOV 	#0x0001, w3 		
	MOV 	w3, OC2RS       
	bset	T3CON, #TON	
	mov		#2,w0  				
	mov		w0,lasersta
	return
	
 ; AUS !
 lasercon0b:
 	call	Laserreset
	MOV 	#0x0001, w3 		
	MOV 	w3, OC2RS       
	bclr	T3CON, #TON
	return
	
; Modus: HAND
lasercon1:
	mov		laserkopfschalter,w0
	cp		w0,#1
	bra		z,lasercon1a
	clr		lasersta
	return
lasercon1a:
	call	PWMhand
	return

; Modus: AUTO
lasercon2:
	mov		laserkopfschalter,w0
	cp		w0,#2
	bra		z,lasercon2a
	clr		lasersta
	return
lasercon2a:
	call	PWMauto   			; > W3
	btsc	inputdaten,#usbaktiv
	bra		lasercon2c
	MOV 	#0x0001, w3 		
	MOV 	w3, OC2RS       
	return
lasercon2c:
	btss	merker,#istunten
	bra		lasercon2d
	mov		w3,OC2RS			; Ausgabe
	return
lasercon2d:
	MOV 	#0x0001, w3 		; fast aus
	MOV 	w3, OC2RS
	return
		
; ------------------------------------
	
; Schaltet die PWM auf AUTO-Betrieb
; berechnet nach XY-Vorschub und Potistellungen
; Ausgang: W3
PWMauto:
 	disi	#2 
 	mov		xweg,w2
 	mov		yweg,w4
 	mov		w2,testram
 	mov		w4,testram+2
; Zeit nach Vorschub umrechnnen
	cp0		w2
	bra		nz,pwmst1
	inc		w2,w2
pwmst1:
 	cp0		w4
	bra		nz,pwmst2
	inc		w4,w4
pwmst2:
	mov		#24400,w8
	repeat	#17
	div.u	w8,w2				; w2:w8= w0, rest in w1
	call	Wegbegrenzen        ; 1...63
	mov		w0,w2
	repeat	#17
	div.u	w8,w4				; w4:w8= w0, Rest in w1
	call	Wegbegrenzen        ; 1...63
	mov		w0,w4
	sl		w4,w4
; Zeiger auf die Tabelle erzeugen
	mov		#128,w0 
	mul.uu	w0,w2,w6			; W0 x W2 = W7,W6
	add		w6,w4,w6
	mov		#psvoffset(pwmtabelle),w5
	add		w6,w5,w5
	mov		[w5],w1				; w1 = PWM-Wert aus Tabelle max. 1429
; mit Potistellung multiplizieren
	mov		reglerpoti,w0  		; 0 bis 1023
	mul.uu	w0,w1,w2			; w0 x w1 = w3,w2
; durch 1024 teilen, also 5 mal nach oben (links) W3<< schieben
	do		#5,pwmst5
	rlc		w2,w2
	rlc		w3,w3
pwmst5:
	mov		linearpoti,w0
	add		w0,w3,w3
; Begrenzen auf 1023
	mov		#1023,w0
	cp		w3,w0
	bra		lt,pwmst6
	mov		w0,w3				; begrenzen
pwmst6:
	mov		w3,laserstrom
	lsr		w3,#2,w3			; soll maximal 255, PWM=14,4kHz
	cp0		w3
	bra		nz,pwmst7
	mov		#1,w3
pwmst7:
	return

; Begrenzen auf 1...63 damit die Zeiger in der Tabelle bleiben
; Eingang: w0 , W1=Rest, Ausgang: W0
Wegbegrenzen:
	cp		w1,#32
	bra		lt,wegbegr1
	inc		w0,w0			; Aufrunden
wegbegr1:
	mov		#63,w7
 	cp		w0,w7  			; ber 39?
 	bra		le,wegbegr3   	; nein
 	mov		w7,w0
wegbegr3:
; 	cp0		w0				; darf nicht auf 0
; 	bra		nz,wegbegr4
; 	mov		#1,w0
wegbegr4:
	return

; testet ob die Z-Achse steht und wo?
; Eingang: (B)zimpulsplus, (B)zimpulsminus (aus Interrupt)
; Ausgang: (B)istoben, (B)istunten
Aufabtest:
	btsc	merker,#zimpulsplus
	bra		aufab1
	btsc	merker,#zimpulsminus
	bra		aufab2
	cp0		lasertimer
	bra		z,aufab3
	return
aufab3:
	btss	merker,#warplus
	bra		aufab4
	bclr	merker,#warplus
	bset	merker,#istoben		 		
	bclr	merker,#istunten		 		
	return
aufab4:
	btss	merker,#warminus
	return
	bclr	merker,#warminus
	bset	merker,#istunten
	bclr	merker,#istoben
	return
; ein Impuls nach oben
aufab1:
	bclr	merker,#zimpulsplus
	bset	merker,#warplus		
	bclr	merker,#warminus
	bclr	merker,#istunten
	bclr	merker,#istoben
	mov		#19,w0				; 14,4 bis 15,2ms
	mov		w0,lasertimer
	return
; ein Impuls nach unten
aufab2:
	bclr	merker,#zimpulsminus
	bset	merker,#warminus
	bclr	merker,#warplus
	bclr	merker,#istoben		
	bclr	merker,#istunten
	mov		#19,w0				; 51ms
	mov		w0,lasertimer
	return
	
; PWM im HAND-Modus nach Poti am Laserkopf einstellen
PWMhand:
	btss	merker,#handfertig
	bra		pwmhand2
	mov		handpoti,w3
	mov		#387,w2
	mul.uu	w2,w3,w2
	swap	w2
	ze		w2,w2
	swap	w3
	ior		w3,w2,w3		
	mov		w3,laserstrom
	lsr		w3,#2,w3		; soll maximal 255, PWM=14,4kHz
	cp		w3,#255
	bra		lt,pwmhand0
	mov		#255,w3
pwmhand0:
	cp0		w3
	bra		nz,pwmhand1
	mov		#1,w3
pwmhand1:
	MOV 	w3, OC2RS       ; Tastverhltnis hier einstellbar
	return
pwmhand2:
	mov		handpoti,w0
	cp		w0,#20
	bra		le,pwmhand3
	MOV 	#0x0001, w3 		; fast aus
	MOV 	w3, OC2RS       	; Tastverhltnis hier einstellbar
	return
pwmhand3:
	bset	merker,#handfertig
	return

Laserreset:
	bclr	merker,#faehrthoch	
	bclr	merker,#istunten	
	bclr	merker,#istoben	
	bclr	merker,#handfertig	
	return
	
			